/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWPF_H
#define _NWPF_H
    

#include <sys/types.h>
#include <sys/time.h>
#include <net/pfilt.h>

#include <block.h>
#include <dnpap.h>

#include "nw.h"
            

#define NWPF_SIZE_ENTRY        32
#define NWPF_SIZE_INTERFACE    32
#define NWPF_SIZE_PACKET     4096
#define NWPF_SIZE_ADDRESS       6

#define NWPF_DEFAULT_FLAGS      (ENTSTAMP | ENBATCH | ENNONEXCL | ENCOPYALL)

#define NWPFDEVICE      "pf0"

                      
enum NwPfErrors
{
    NWPF_OK = NWPF_ERROR, 
    NWPF_PARAM, NWPF_OPEN, NWPF_NEWPF, NWPF_INIT,
    NWPF_SETUP,  NWPF_IOCTL, NWPF_BLOCK,
    NWPF_ADDLIST, NWPF_SEND, NWPF_READ, 
    NWPF_WEVENT, NWPF_EEVENT, NWPF_NEVENT,
	NWPF_CONFIG
};


typedef struct enstamp ENSTAMP;
typedef struct enfilter ENFILTER;
typedef struct endevp ENDEVP;


typedef struct _NwPf
{
	INT Socket;
	CHAR *Interface;
    BYTE  Address[NWPF_SIZE_ADDRESS];
	INT BufSize;
	INT SnapLen;
	TIMEVAL Timeout;
	INT Flags;
	BYTE *Buf;
	LONG  Pos;
	LONG  End;
	         
} NwPf;
    

typedef struct _NwPfDg
{          
    NW_DG  NwInfo;
    NwPf   PfInfo;
    
    BLOCK          *Block;
    
    struct _NwPfDg *Prev;
    struct _NwPfDg *Next;
    
} NwPfDg;

      

extern NW_DG_IFACE PfDgIface;


BOOLEAN NwPfInit(VOID);
BOOLEAN NwPfExit(VOID);

NW_DG  *NwPfAccept(char *addr, NW_DG_RECV_CALL recv, VOID *param);
NW_DG  *NwPfConnect(char *addr, NW_DG_RECV_CALL recv, VOID *param);
BOOLEAN NwPfSend(NW_DG *dg, BYTE *frame, INT len);
BOOLEAN NwPfSendTo(NW_DG *dg, char *addr, BYTE *frame, INT len);
BOOLEAN NwPfClose(NW_DG *dg);
BOOLEAN NwPfIfConfig(NW_DG *dg, NW_IFCONFIG *ifconfig);


#endif
